<?php
/*****************************************************************************
 * ID   : $Id: SmtTemplate.php,v 1.1 2007/03/16 14:05:52 secondarykey Exp $
 * Name : 
 * Specifications :
 ****************************************************************************/
require_once('application.php');
require_once('pager.php');
require_once('Smarty.class.php');
/**
 * 
 */
class SmtTemplate extends Smarty {

	/**
	 * ページの表示件数
	 */
	var $myDisplayPageNum = 10;

	/**
	 * コンストラクタ
	 */
	function SmtTemplate()
	{
        // クラスのコンストラクタ。これらは新しいインスタンスで自動的にセットされます。
        $this->Smarty();
        $this->template_dir = SiteObject::get("SMARTY_TEMPLATE_PATH");
        $this->compile_dir  = SiteObject::get("SMARTY_COMPILE_PATH");
        $this->config_dir   = SiteObject::get("SMARTY_CONFIG_PATH");
        $this->cache_dir    = SiteObject::get("SMARTY_CACHE_PATH");
	}

	function activeButton($aActive) {
		$this->assign('menu_button_page','deactive');
		$this->assign('menu_button_resource','deactive');
		$this->assign('menu_button_template','deactive');
		$this->assign('menu_button_log','deactive');
		$this->assign('menu_button_site','deactive');
		$this->assign('menu_button_convert','deactive');
		//アクティブなボタンを設定	
		$this->assign('menu_button_' . $aActive ,'active');
		return;
	}

	/**
	 * ページャ作成
	 * 算術的な計算のみを行い実際の文字列はPagerクラスに任せる
	 */
	function createPager($aTables,$aRequestPageName) {

		//テーブル設定から最大ページ数を取得
		$maxPage = $aTables->getMaxPageNum();
		$nowPage = $aTables->getRequestPageNum();

		//ページャーを生成(ページ名称,現在のページ,最後のページ,ページリスト表示数)
		$pager = new Pager($aRequestPageName);
		//解析を行う
		$pager->analytics($nowPage,$maxPage,$this->myDisplayPageNum);
		//ページャーを返す
		return $pager;		
	}

	/**
	 * 表示可能ページの設定
	 */	
	function setDisplayPageNum($aDisplayPageNum) {
		//表示可能ページ数を設定する
		$this->myDisplayPageNum = $aDisplayPageNum;
	}
} 

?>
