<?php
/*****************************************************************************
 * ID   : $Id: tables.php,v 1.1 2007/03/16 14:05:52 secondarykey Exp $
 * Name : 
 * Specifications :
 ****************************************************************************/
  class tables {

	/**
	 * selectByLimit上限数
	 */ 
 	var $myLimit = 10; 
 
	//myLimit,myPageにした際の最高ページ数
 	var $myMaxPageNum = 1;

	//リクエストしたページ数
 	var $myRequestPageNum = 1;
 	
 	//データカウント
 	var $myCount = -1;
 
  	/**
  	 * カウント数取得
  	 */	
	function getCount($aWhere="") {
 
		$con = DatabaseAccess::getConnection();
		$sql = "select count(*) from " . $this->myTableName . $aWhere;
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return 0;
		}
		$row = mysql_fetch_array($query); 

		$count = $row[0];
		mysql_free_result($query);
		//カウント数を更新	
		$this->myCount = $count;
		return $count;
  	}
  
  	/**
  	 * 全件検索を行う
  	 */	
	function select() {
		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "select " . $this->myColumnName . " from " . $this->myTableName .
		       " order by " .$this->myOrderBy;
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			return null;
		}
		$idx = 0;
		$rtn = array();
		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = $this->createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		mysql_free_result($query);
		return $rtn;
	}

	/**
	 * 指定したIDで検索を行う
	 */	
	function selectByID($aID) {
		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "select " . $this->myColumnName . " from " . $this->myTableName . 
               " where " . $this->myOrgWhere . "=" . $aID . " order by " .$this->myOrderBy;
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			return null;
		}
		$idx = 0;
		$rtn = array();
		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = $this->createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		//結果は使用側が行うこと
		mysql_free_result($query);
		return $rtn;	
	}

	/**
	 * 指定したページ数から取得したいデータのみを取得
	 */
	function selectByPage($aPageNum,$aWhere = "") {

		//リクエストページを更新
		$this->myRequestPageNum = $aPageNum;

		//カウントを取得	
		$cnt = $this->getCount($aWhere);
		$limit = ($aPageNum * $this->myLimit) - $this->myLimit;
		//指定したページが表示件数を超えた場合
		if ( $limit >= $cnt ) {
			return null;
		}
	
		//０件だった場合	
		if ( $this->myLimit == 0 ) {
			//件数を制限に設定
			$this->myLimit = $cnt;
		}

		//表示可能ページ数を設定する
		$this->myMaxPageNum = (int)($cnt / $this->myLimit);
		//ちょうど割れない場合	
		if ( ($cnt % $this->myLimit) > 0 ) {
			//１つページ数を加算する
			$this->myMaxPageNum = $this->myMaxPageNum + 1;
		}

		//コネクションを取得
		$con = DatabaseAccess::getConnection();

		//SQLを設定
		$sql = "select " . $this->myColumnName . " from " . $this->myTableName . $aWhere .
               " order by " . $this->myOrderBy . " limit " . $this->myLimit . " offset " . $limit;
        
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			mysql_free_result($query);
			return null;
		}
		$idx = 0;
		$rtn = array();
		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = $this->createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		//結果は使用側が行うこと
		mysql_free_result($query);
		return $rtn;
	}

	/**
	 * 行追加
	 */	
	function insert() {
		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "insert into " . $this->myTableName . "(" . $this->myInsertColumnName . ")" .
               " values(" . $this->getInsertValue() . ")";
		//SQLを実行
		$rtn =  mysql_query($sql,$con);
		if ( $rtn == null ) {
			return FALSE;
		}
		//インサートされたIDを設定
		$this->setID(mysql_insert_id());

		return TRUE;
	}

	/**
	 * 指定行更新
	 */
	function update($aID) {
		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		$sql = "update " . $this->myTableName ." set " . $this->getUpdateValue() .
		       " where " . $this->myOrgWhere ."=". $aID;
 		$rtn = mysql_query($sql,$con);
 		//失敗したら。。。
 		if ( $rtn == null ) {
			return FALSE;
		}
		return TRUE;
	}

	/**
	 * 指定行削除
	 */
	function delete($aID) {
		
		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		$sql = "delete from " . $this->myTableName .
		       " where " . $this->myOrgWhere ."=". $aID;
 		$rtn = mysql_query($sql,$con);
 		//更新への行数がわからない
 		if ( $rtn == null ) {
			return FALSE;
		}
		return TRUE;
	}
	
	/**
	 * カウント数を取得
	 */	
	function getTableCount() {
		return $this->myCount;
	}

	/**
	 * 上限行数変更
	 */
	function setLimit($aLimit) {
		$this->myLimit = $aLimit;
	}

	/**
	 * 最高ページ数取得
	 */	
	function getMaxPageNum() {
		return $this->myMaxPageNum;
	}

	/**
	 * 指定したページ番号
	 */
	function getRequestPageNum() {
		return $this->myRequestPageNum;
	}

  }
?>
