<?php
/*****************************************************************************
 * ID   : $Id: template_page_attribute_exec.php,v 1.2 2007/08/18 08:04:24 secondarykey Exp $
 * Name : ページテンプレート属性定義実行	
 * Specifications : ページテンプレートの属性定義の実行を行う
 ****************************************************************************/
//全クラスの読み込み
require_once('application.php');

/****************************************************
 * 引数を取得する
 ****************************************************/
$id = "";

//引数解析
if ( isset($_POST['id']) ) {
	$id = $_POST['id'];
}

$error = 0;

//コネクションに対してトランザクションを行う
//テーブル名を作成
$tableName = "page_attribute" . $id . "_tb";
$sql = "create table " . $tableName . " (";
$sql = $sql . "id bigint unsigned auto_increment primary key,";		
$sql = $sql . "pageid bigint,";

//エラーフラグ
$variArray = array();
//スキーマに入れる変数を入力
$insertArray = array();

//データを取得する
for ( $cnt = 1; $cnt <= 100; ++$cnt ) {
	
	//変数名称を取得
	$nameName     = "name"     . $cnt;
	$variableName = "variable" . $cnt;
	$typeName     = "type"     . $cnt;
	$mustName     = "must"     . $cnt;
	$argName      = "arg"      . $cnt;

	$name     = "";
	$variable = "";
	$type     = "";
	$must     = "";
	$arg      = "";
	if ( isset($_POST[$nameName]) ) {
		$name = $_POST[$nameName];
	}
	if ( isset($_POST[$variableName]) ) {
		$variable = $_POST[$variableName];
	}
	if ( isset($_POST[$typeName]) ) {
		$type = $_POST[$typeName];
	}
	if ( isset($_POST[$mustName]) ) {
		$must = $_POST[$mustName];
	}
	if ( isset($_POST[$argName]) ) {
		$arg = $_POST[$argName];
	}

	//データが存在しない場合
	if ( $name == "" && $variable == "" ) {
		break;
	}
	//変数名がない場合
	if ( $variable == "" ) {
		$error = $error + 1;
		break;
	}
	
	$variFlag = $variArray[$variable];
	//フラグが存在しない場合
	if ( $variFlag != null ) {	
		//エラーにする
		$error = $error + 1;
	}
	//変数のフラグを立てる
	$variArray[$variable] = true;
	
	$clmType = "text";
	//画像マスタ、マスタ指定の場合
	if ( $type == 6 || $type == 7 ) {
		$clmType = "bigint";
	}

	//マスタ指定の場合
	if ( $type == 6 ) {
		//指定がない場合
		if ( $arg == "" ) {
			//エラーにする
			$error = $error + 1;
		}
	}

	//カラム名と型を設定	
	$clm = $variable . " " . $clmType;		
	//必須の場合	
	if ( $must == 1 ) {
		$clm = $clm . " not null";
	}

	//同一でない場合
	if ( $cnt != 1 ) {
		$clm = "," . $clm;	
	}
	//設定する
	$sql = $sql . $clm;	

	//空の場合、NULLを設定する
	if ( $arg == "" ) {
		$arg = "NULL";
	}

	//スキーマ登録を行う	
	$schema_tb = new schema_tb();
	//データ定義を行う
	$schema_tb->setTemplate_Page_ID($id);
	$schema_tb->setName($name);
	$schema_tb->setVariable($variable);
	$schema_tb->setVariableType($type);
	$schema_tb->setMust($must);
	$schema_tb->setArg($arg);
	//配列に溜め込む
	$insertArray[$cnt] = $schema_tb;
}

$sql = $sql . ")";		

//データ定義をテーブルで行う
if ( $error == 0 ) {
	foreach ( $insertArray as $tb ) {
		$tb->insert();	
	}
	//コネクションを取得	
	$con = DatabaseAccess::getConnection();
	//テーブルを作成する
	//SQLを実行
	$query = mysql_query($sql,$con);
}

header("Location: template_page_attribute.php?id=".$id);
?>
