<?php
/*****************************************************************************
 * ID   : $Id: ApplicationObject.php,v 1.1 2007/03/16 14:05:52 secondarykey Exp $
 * Name : 
 * Specifications :
 ****************************************************************************/
class ApplicationObject
{
	var $myDBServer = "SERVER";
	var $myDBUser = "USER";
	var $myDBPassword = "PASSWORD";
	var $myDBName = "NAME";

	function write($aFileName) {
	
		$path = $aFileName . 'class/application.php';

		//ファイルを開く	
		$fp = fopen($path, "r") ;
		//ファイルを配列に格納
		$lineArray = array();
		while( !(feof($fp) ) ) {
			$buf = fgets($fp, 1024);
			$buf = chop($buf);
			$lineArray[] = $buf;
		}
		fclose($fp);
	
		$val = "";
		$other = "";

		$flag = false;
		$idx = 1;
	
		$writeArray = array();
	
		foreach ( $lineArray as $line ) {
		
			$s_idx = strpos($line,'START');
			$e_idx = strpos($line,'END');
		
			if ( $s_idx == "" ) $s_idx = -1;
			if ( $e_idx == "" ) $e_idx = -1;
		
			if ( $s_idx < 0 && $e_idx < 0 ) {	
				if ( $flag ) {
					$idx = strpos($line,"DATABASE_SERVER");
					if ( $idx != "" && $idx >= 0 ) {
						$line = "define('DATABASE_SERVER','" . $this->myDBServer . "');";
					}
					$idx = strpos($line,"DATABASE_USER");
					if ( $idx != "" && $idx >= 0 ) {
						$line = "define('DATABASE_USER','" . $this->myDBUser . "');";
					}
					$idx = strpos($line,"DATABASE_PASSWORD");
					if ( $idx != "" && $idx >= 0 ) {
						$line = "define('DATABASE_PASSWORD','" . $this->myDBPassword . "');";
					}
					$idx = strpos($line,"DATABASE_NAME");
					if ( $idx != "" && $idx >= 0 ) {
						$line = "define('DATABASE_NAME','" . $this->myDBName . "');";
					}
				}
			} else if ( $s_idx >= 0 ) {
				$flag = true;
			} else if ( $e_idx >= 0 ) {
				$flag = false;
			}
		
			$writeArray[] = $line;
		}
	
		//ファイルを開く	
		$fp = fopen($path, "w") ;
		$len = count($writeArray);	
		$idx = 1;
		foreach ( $writeArray as $line ) {
			if ( $idx != $len ) {
				$wkline = $line . "\n";
			} else {
				$wkline = $line;
			}
			fwrite($fp,$wkline);
			$idx++;
		}
		fclose($fp);
	}
	
	
	function setDBServer($aArg) {
		$this->myDBServer = $aArg;
	}
	function setDBUser($aArg) {
		$this->myDBUser = $aArg;
	}
	function setDBPassword($aArg) {
		$this->myDBPassword = $aArg;
	}
	function setDBName($aArg) {
		$this->myDBName = $aArg;
	}
}
?>
